Bug 159708 - Tape configuration does not work correctly
Tape configuration does not work correctly
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: iscsi-initiator-utils (Show other bugs)
4.0
i686 Linux
medium Severity high
: ---
: ---
Assigned To: Mike Christie
Brock Organ
:
Depends On:
Blocks: 166275
  Show dependency treegraph
 
Reported: 2005-06-07 07:20 EDT by Nitin Chandna
Modified: 2012-06-20 09:17 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-06-20 09:17:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Nitin Chandna 2005-06-07 07:20:43 EDT
Description of problem:
After configuring a Tape LUN, iscsi-ls -l shows the device mapped to. But it
also gives some error message as well. If any IO is executed on this tape, the
linux host panics and crashes.

Version-Release number of selected component (if applicable):
- kernel-smp-2.6.9-11.EL
- kernel-smp-devel-2.6.9-11.EL

How reproducible:
Always reproducible

Steps to Reproduce:
1. Configured a tape (Quantum ATL1500) LUN on MDS 9216
2. Execution of iscsi-ls -l gives the following output:
[root@cnitin-linux-6 ~]# iscsi-ls -l
*******************************************************************************
SFNet iSCSI Driver Version ...4:0.1.11(12-Jan-2005)
*******************************************************************************
TARGET NAME             : iqn.2004-04.com.cisco.cnitin-tape-drive-2
TARGET ALIAS            : 
HOST ID                 : 0
BUS ID                  : 0
TARGET ID               : 0
TARGET ADDRESS          : 10.1.1.80:3260,12416
SESSION STATUS          : ESTABLISHED AT Wed Jun  1 16:00:00 IST 2005
SESSION ID              : ISID 00023d000001 TSIH 3080

DEVICE DETAILS:
---------------
LUN ID : 0
  Vendor: QUANTUM  Model: SuperDLT1        Rev: 2323
  Type:   Sequential-Access                ANSI SCSI revision: 04
open class /sys/block/st0 failed: No such file or directory
  page83 type0: 
open class /sys/block/st0 failed: No such file or directory
  page80: 
  Device: /dev/st0
*******************************************************************************

  
Actual results:
iscsi-ls -l gives errors when a tape LUN is configured.
Also, an IO on tape device displayed panics the system.


Expected results:
iscsi-ls -l should display the tape details without errors. An IO on tape should
not panic the system.

Additional info:
(1) At one point of time when the crash happened, could gather the following
information from the system console:
Call Trace:
[<e883e47d>]	scsi_device_unbusy+0x46/0x5b	[scsi_mod]
[<e883ab15>]	scsi_finish_command+0xad/0xb	[scsi_mod]
[<e883aa3a>]	scsi_softirq+0xb6/0xbe	[scsi_mod]
[<c0125a5c>]	__do_softirq+0x4c/0xb1
[<c010806d>]	do_softirq+0x4f/0x56
=======================================
=======================================
[<e8a8fd6b>]	iscsi_recv_pdu+0x178/0x249	[iscsi_sfnet]
[<c01173fd>]	smp_apic_timer_interrupt+0xd9/0xdd
[<c02c7db6>]	apic_timer_interrupt+0x1/0x20
[<e8a8c839>] 	iscsi_rx_thread+0x0/0x1e7	[iscsi_sfnet]
[<e8a8c900>]	iscsi_rx_thread+0xc7/0x1e7	[iscsi_sfnet]
[<c0132e31>]	kthread+0x73/0x9b
[<c0132dbe>]	kthread+0x0/0x9b
[<c01041f1>]	kernel_thread_helper+0x5/0xb

<0> Kernel panic: not syncing: Fatal Exception interrupt

(2) At another ocassion when crash happened, captured the following from the log
messages:
Jun  1 15:51:14 cnitin-linux-6 kernel: scsi0 : SFNet iSCSI driver
Jun  1 15:51:14 cnitin-linux-6 kernel:   Vendor: QUANTUM   Model: SuperDLT1    
    Rev: 2323
Jun  1 15:51:14 cnitin-linux-6 kernel:   Type:   Sequential-Access             
    ANSI SCSI revision: 04
Jun  1 15:51:15 cnitin-linux-6 scsi.agent[4082]: tape at
/devices/platform/host0/target0:0:0/0:0:0:0
Jun  1 15:51:15 cnitin-linux-6 kernel: st: Version 20040403, fixed bufsize
32768, s/g segs 256
Jun  1 15:51:15 cnitin-linux-6 kernel: Attached scsi tape st0 at scsi0, channel
0, id 0, lun 0
Jun  1 15:51:15 cnitin-linux-6 kernel: st0: try direct i/o: yes (alignment 512
B), max page reachable by HBA 1048575
Jun  1 15:51:17 cnitin-linux-6 hald[3501]: Timed out waiting for hotplug event
271. Rebasing to 272
Jun  1 15:52:10 cnitin-linux-6 kernel: st0: Block limits 4 - 16777212 bytes.
Jun  1 15:52:10 cnitin-linux-6 kernel: st0: Write not multiple of tape block size.




Jun  1 15:52:25 cnitin-linux-6 kernel: st0: Write not multiple of tape block size.
Jun  1 15:52:59 cnitin-linux-6 kernel: Unable to handle kernel NULL pointer
dereference at virtual address 00000190
Jun  1 15:52:59 cnitin-linux-6 kernel:  printing eip:
Jun  1 15:52:59 cnitin-linux-6 kernel: e89adc96
Jun  1 15:52:59 cnitin-linux-6 kernel: *pde = 1e65e001
Jun  1 15:52:59 cnitin-linux-6 kernel: Oops: 0000 [#1]
Jun  1 15:52:59 cnitin-linux-6 kernel: SMP 
Jun  1 15:52:59 cnitin-linux-6 kernel: Modules linked in: st crc32c libcrc32c
iscsi_sfnet(U) md5 ipv6 parport_pc lp parport autofs4 i2c_dev i2c_core sunrpc
scsi_transport_iscsi(U) button battery ac e100 mii e1000 floppy dm_snapshot
dm_zero dm_mirror ext3 jbd dm_mod cpqarray sd_mod scsi_mod
Jun  1 15:52:59 cnitin-linux-6 kernel: CPU:    1
Jun  1 15:52:59 cnitin-linux-6 kernel: EIP:    0060:[<e89adc96>]    Not tainted VLI
Jun  1 15:52:59 cnitin-linux-6 kernel: EFLAGS: 00010246   (2.6.9-11.ELsmp) 
Jun  1 15:52:59 cnitin-linux-6 kernel: EIP is at read_tape+0xfd/0x3c9 [st]
Jun  1 15:52:59 cnitin-linux-6 kernel: eax: 00000000   ebx: e7811800   ecx:
dfebcf70   edx: e7ce1400
Jun  1 15:52:59 cnitin-linux-6 kernel: esi: 00000000   edi: e7ce1400   ebp:
00000000   esp: dfebcf08
Jun  1 15:52:59 cnitin-linux-6 kernel: ds: 007b   es: 007b   ss: 0068
Jun  1 15:52:59 cnitin-linux-6 kernel: Process tar (pid: 4270,
threadinfo=dfebc000 task=e5f06150)
Jun  1 15:52:59 cnitin-linux-6 kernel: Stack: 00000000 00000001 00000000
e78872cc 00000000 dfe2c800 e7ce14c8 dfebcf70 
Jun  1 15:52:59 cnitin-linux-6 kernel:        e7ce1400 00000108 00000000
00000000 00000000 08217800 00000000 00000000 
Jun  1 15:52:59 cnitin-linux-6 kernel:        dfebc000 e89ae1fc 00000000
dfe2c800 e7ce14c8 e7ce1400 00000003 00002800 
Jun  1 15:52:59 cnitin-linux-6 kernel: Call Trace:
Jun  1 15:52:59 cnitin-linux-6 kernel:  [<e89ae1fc>] st_read+0x29a/0x3cf [st]
Jun  1 15:53:00 cnitin-linux-6 kernel:  [<c0156011>] vfs_read+0xb6/0xe2
Jun  1 15:53:00 cnitin-linux-6 kernel:  [<c0156224>] sys_read+0x3c/0x62
Jun  1 15:53:00 cnitin-linux-6 kernel:  [<c02c7377>] syscall_call+0x7/0xb
Jun  1 15:53:00 cnitin-linux-6 kernel: Code: 00 89 e8 88 54 24 20 0f 95 44 24 1d
c1 f8 10 88 44 24 1e 89 e8 c1 f8 08 88 44 24 1f 8b 19 6a 01 6a 00 8b 7c 24 20 8b
47 04 89 fa <ff> b0 90 01 00 00 89 d8 6a 02 56 8d 4c 24 30 e8 83 e6 ff ff 89 
Jun  1 15:53:00 cnitin-linux-6 kernel:  <0>Fatal exception: panic in 5 seconds
Jun  1 15:53:00 cnitin-linux-6 kernel: iscsi-sfnet:host0: Session dropped
Comment 1 Mike Christie 2005-06-17 17:16:15 EDT
open class /sys/block/st0 failed: No such file or directory

That is a bug in that iscsi-ls should not look for tape in the block dir. It has
a gend_disk but it never has add_disk() called on it. Nitin could you have
Smitha fix that one since we do not have iSCSI tape here? It is pretty trivial I
can send a patch for what I think is right if Smitha has no time and you want to
be the test subject.

As for the io error. I think I know what this is. I will send something to test
later.
Comment 2 Mike Christie 2005-06-27 13:37:22 EDT
ok so Smitha fixed the iscsi-ls bug.

I am looking into the oops, but do not have iscsi tape (have been trying to hack
virtual iscsi tape support into IET over the weekend).
Comment 3 Mike Christie 2005-06-27 15:12:21 EDT
Arg!. Smitha could you take this? Hacking in tape support to a target to fix a
tape bug is too much trouble :( Citin, If you can replicate on a disk let me
know and I will help.
Comment 4 Jiri Pallich 2012-06-20 09:17:52 EDT
Thank you for submitting this issue for consideration in Red Hat Enterprise Linux. The release for which you requested us to review is now End of Life. 
Please See https://access.redhat.com/support/policy/updates/errata/

If you would like Red Hat to re-consider your feature request for an active release, please re-open the request via appropriate support channels and provide additional supporting details about the importance of this issue.

Note You need to log in before you can comment on or make changes to this bug.